SystemOrganization addCategory: #'Mabinogi-Core'!

Object subclass: #MbDefinition
	instanceVariableNames: 'label required formatter rules selector model typeHint renderHint valuesBlock precision currency'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbDefinition commentStamp: 'StuartHerring 1/7/2012 13:58' prior: 0!
I represent the defintion of a field within an object and present the additional meta-information required to enable automatic validation and presentation of the field.!

!MbDefinition class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2012 18:34'!
selector: aSelector 
	^self basicNew
		initializeWithSelector: aSelector;
		yourself! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:59'!
assertValid: aValue
	[required ifTrue: [ MbRequiredRule new assertValid: aValue ].
		aValue ifNotNil: [ rules do: [ :r | r assertValid: aValue ]]] 
	on: MbValidationError do: [ :e | e setDefinition: self; signal ]! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:21'!
currency 
	^currency! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:20'!
currency: aCurrencySymbol
	currency := aCurrencySymbol.
	self numeric: 2! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:27'!
date: aBoolean
	aBoolean
		ifTrue: [ 
			self typeHint: #date.
			rules add:
					(MbRule
						validationBlock: [ :v | 
							[ v asDate ] on: Error do: [ :err | MbValidationError signalForDefintion: self ] ]).
			self renderHint: #datePicker ]! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:20'!
initializeWithSelector: aSelector
	self initialize.
	selector := aSelector.
	label := aSelector asCapitalizedPhrase.
	required := false.
	rules := OrderedCollection new.
	typeHint := #string.
	precision := nil.! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/11/2012 10:32'!
label
	^label! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2012 16:55'!
label: aLabel
	label := aLabel! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:34'!
numeric: aBooleanOrNumber
	self typeHint: #numeric.
	rules add: (MbRule validationBlock: [ :v | [v asNumber] on: Error do: [ :err | MbValidationError signalForDefintion: self ] ]).
	aBooleanOrNumber isNumber ifTrue: [
		precision := aBooleanOrNumber].! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:18'!
precision
	^precision! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:41'!
renderHint
	^renderHint! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:41'!
renderHint: aSymbol
	renderHint := aSymbol! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2012 18:36'!
required
	^required! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2012 18:39'!
required: aBoolean
	required := aBoolean.! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/10/2012 18:38'!
selector
	^selector! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2012 08:30'!
setModel: anObject
	model := anObject! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:09'!
setModelValue: aValue
	model perform: selector asMutator with: aValue! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:38'!
typeHint
	^typeHint! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:38'!
typeHint: aSymbol
	typeHint := aSymbol! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 19:07'!
valueSelector: aSymbol
	valuesBlock := [model perform: aSymbol].
	rules add: (MbRestrictedValueRule valuesBlock: valuesBlock).
	self renderHint: #dropDown! !

!MbDefinition methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 19:07'!
values
	^valuesBlock value! !

Object subclass: #MbObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbObject class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:23'!
mbDefinitionFor: aField
	| method |
	method := self lookupSelector: aField.
	^ method category = self mbFieldCategory
		ifFalse: [ nil ]
		ifTrue: [ 
			method pragmas
				inject: (MbDefinition selector: aField)
				into: [ :def :p | 
					[ 
					p numArgs > 0
						ifTrue: [ p sendTo: def ]
						ifFalse: [ def perform: p keyword asMutator with: true ] ]
						on: MessageNotUnderstood
						do: [ :err |  ].	"Assume unknown pragmas aren't for us"
					def ] ]! !

!MbObject class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:49'!
mbFieldCategory
	^'accessing'! !

!MbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:01'!
isEmptyOrNil
	^false! !

!MbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2012 10:27'!
mbDefinitionFor: aSymbol
	^(self class mbDefinitionFor: aSymbol)
		ifNotNil: [ :d | d setModel: self; yourself]! !

!MbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2012 08:48'!
mbDefinitions
	^(self class selectorsWithArgs: 0)
		collect: [ :s | self mbDefinitionFor: s ] 
		thenSelect: [ :def | def notNil]! !

!MbObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/29/2012 08:27'!
set: aField to: aValue
	(self mbDefinitionFor: aField) 
		assertValid: aValue.
	self instVarNamed: aField put: aValue! !

Object subclass: #MbRule
	instanceVariableNames: 'validationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

MbRule subclass: #MbRequiredRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbRequiredRule class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:04'!
new
	^self validationBlock: [ :aValue |
			(aValue isNil or: [ aValue isCollection and: [ aValue isEmpty]]) ifTrue: [ MbRequiredFieldError signal ]]! !

MbRule subclass: #MbRestrictedValueRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbRestrictedValueRule class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:05'!
valuesBlock: valuesBlock
	^self validationBlock: [ :aValue |
	(valuesBlock value includes: aValue) ifFalse: [ MbValidationError signal ]]! !

!MbRule class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:02'!
validationBlock: aBlock
	^self basicNew
		initializeWithBlock: aBlock;
		yourself! !

!MbRule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:01'!
assertValid: aValue
	validationBlock value: aValue.! !

!MbRule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:02'!
initializeWithBlock: aBlock
	self initialize.
	validationBlock := aBlock.! !

Error subclass: #MbValidationError
	instanceVariableNames: 'definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

MbValidationError subclass: #MbRequiredFieldError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Core'!

!MbRequiredFieldError methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:06'!
message
	^'{1} is required' format: { definition label }! !

!MbValidationError class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:03'!
signalForDefintion: aDefinition
	self new
		setDefinition: aDefinition;
		signal! !

!MbValidationError methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:57'!
message
	^'{1} invalid' format: { definition label }! !

!MbValidationError methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:57'!
setDefinition: aDefinition
	definition := aDefinition! !
